<%@page contentType="text/html; charset=Windows-31J"%>
<%@taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@taglib prefix="sql" uri="http://java.sun.com/jsp/jstl/sql"%>
<%-- ڑ --%>
<sql:setDataSource var="db" driver="org.postgresql.Driver"
  url="jdbc:postgresql://localhost:5432/uitest" user="dbuser"/>
<%-- s̓ւ --%>
<c:if test="${param.mode=='swap'}">
  <sql:transaction dataSource="${db}">
    <%-- ws̍sԍ擾 --%>
    <sql:query var="data" sql="select * from t_data where id=?">
      <sql:param value="${param.code}"/>
    </sql:query>
    <c:set var="currentnumber" value="${data.rows[0].number}"/>
    <%-- ւs̍sԍ擾 --%>
    <sql:query var="data">
      select * from t_data where number=
        (select min(number) from t_data where number>?)
      <sql:param value="${currentnumber}"/>
    </sql:query>
    <c:set var="swapline" value="${data.rows[0].number}"/>
    <c:set var="swapid" value="${data.rows[0].id}"/>
    <%-- ւs --%>
    <sql:update sql="update t_data set number=? where id=?">
      <sql:param value="${swapline}"/>
      <sql:param value="${param.code}"/>
    </sql:update>
    <sql:update sql="update t_data set number=? where id=?">
      <sql:param value="${currentnumber}"/>
      <sql:param value="${swapid}"/>
    </sql:update>
  </sql:transaction>
  <c:redirect url="order.jsp"/>
</c:if>
<%-- ꗗ̎擾 --%>
<sql:query dataSource="${db}" var="data">
  select * from t_data order by number
</sql:query>
<%-- ꗗ\ --%>
<table>
<c:forEach var="row" items="${data.rows}" varStatus="status"><tr>
  <td>${row.name}</td>
  <td><c:if test="${status.index > 0}">
  <a href="order.jsp?mode=swap&code=${preid}"></a>
  </c:if></td>
  <td><c:if test="${status.index < data.rowCount - 1}">
  <a href="order.jsp?mode=swap&code=${row.id}"></a>
  </c:if></td>
  <c:set var="preid" value="${row.id}"/>
</tr></c:forEach>
</table>